// WandererDoc.cpp : CWandererDoc NX̓̒`s܂B
//

#include "stdafx.h"
#include "Wanderer.h"

#include "WandererDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMaze
IMPLEMENT_SERIAL(CMaze,CObject,0)

CMaze::CMaze()
{

}

CMaze::~CMaze()
{

}

void CMaze::Serialize(CArchive& ar)
{
	if(ar.IsStoring())
	{
		for(int i=0;i<WIDTH*HEIGHT;i++){
			ar << (DWORD)m_be[0][i];
			ar << (DWORD)m_be[1][i];
		}
		for(int j=0;j<6;j++){
			ar << (DWORD)m_route[j];
		}
		ar << (DWORD)m_here.island;
		ar << (DWORD)m_here.bridge;
		ar << (DWORD)m_here.toward;
	}else{
		for(int i=0;i<WIDTH*HEIGHT;i++){
			ar >> (DWORD&)m_be[0][i];
			ar >> (DWORD&)m_be[1][i];
		}
		for(int j=0;j<6;j++){
			ar >> (DWORD&)m_route[j];
		}
		ar >> (DWORD&)m_here.island;
		ar >> (DWORD&)m_here.bridge;
		ar >> (DWORD&)m_here.toward;
	}
}

void CMaze::NewMaze()              //VɖH쐬
{
	srand((unsigned)time(NULL));
    int amount;
    do 
    {
        amount=0;
		int x,y,h;
		int point[WIDTH*HEIGHT];
    	for(y=0;y<WIDTH*HEIGHT;y++)
		{
            point[y]=y;
            for(x=0;x<2;x++){
				int randam=rand()%10;
                if(randam<7)
					m_be[x][y]=TRUE;
				else
					m_be[x][y]=FALSE;
	        }
        }
		m_be[0][0]=TRUE;
        for(h=0;h<5;h++){
            for(y=0;y<WIDTH*HEIGHT-1;y++){
                if(y%WIDTH==WIDTH-1){
                    if(m_be[1][y]==TRUE){
                        point[y]=point[y+WIDTH]=(point[y]<point[y+WIDTH])?point[y]:point[y+WIDTH];
                    }
                }else if(y>=(HEIGHT-1)*WIDTH){
                    if(m_be[0][y]==TRUE){
                        point[y]=point[y+1]=(point[y]<point[y+1])?point[y]:point[y+1];
                    }
                }else{
					if(m_be[0][y]==TRUE && m_be[1][y]==TRUE){
                        point[y]=(point[y]<point[y+1])?point[y]:point[y+1];
                        point[y]=(point[y]<point[y+WIDTH])?point[y]:point[y+WIDTH];
                        point[y+1]=point[y+WIDTH]=point[y];
                    }else if(m_be[0][y]==TRUE && m_be[1][y]==FALSE){
                        point[y]=point[y+1]=(point[y]<point[y+1])?point[y]:point[y+1];
                    }else if(m_be[0][y]==FALSE && m_be[1][y]==TRUE){
                        point[y]=point[y+WIDTH]=(point[y]<point[y+WIDTH])?point[y]:point[y+WIDTH];
                    }
                }        
            }
        }
        for(y=0;y<HEIGHT*WIDTH;y++){
            amount+=point[y];
        }
	}
	while(amount!=0);
	
	//݈ʒȕ
    m_here.bridge=m_here.island=m_here.toward=0;

	CheckRoute();
}

void CMaze::CheckRoute()
{
    BOOL routeCheck[6];
    for(int i=0;i<6;i++){
        routeCheck[i]=TRUE;
    }

    if(m_here.island/WIDTH==0 && m_here.toward==1 && m_here.bridge==1){
    	routeCheck[1]=FALSE;
    	if(m_here.island%WIDTH==0){
    	    routeCheck[0]=FALSE;
    	}else if(m_here.island%WIDTH==WIDTH-1){
    	    routeCheck[2]=FALSE;
    	}
    }else if(m_here.island/WIDTH==1 && m_here.toward==1 && m_here.bridge==1){
        routeCheck[4]=FALSE;
    	if(m_here.island%WIDTH==0){
    	    routeCheck[0]=FALSE;
    	    routeCheck[3]=FALSE;
    	}else if(m_here.island%WIDTH==WIDTH-1){
    	    routeCheck[2]=FALSE;
    	    routeCheck[5]=FALSE;
        }
    }else if(m_here.island/WIDTH==HEIGHT-3 && m_here.toward==0 && m_here.bridge==1){
	    routeCheck[4]=FALSE;
	    if(m_here.island%WIDTH==0){
	        routeCheck[2]=FALSE;
        	routeCheck[5]=FALSE;
	    }else if(m_here.island%WIDTH==WIDTH-1){
    	    routeCheck[0]=FALSE;
    	    routeCheck[3]=FALSE;
    	}
    }else if(m_here.island/WIDTH==HEIGHT-2 && m_here.toward==0 && m_here.bridge==1){
    	routeCheck[1]=FALSE;
	    if(m_here.island%WIDTH==0){
	        routeCheck[2]=FALSE;
        }else if(m_here.island%WIDTH==WIDTH-1){
	        routeCheck[0]=FALSE;
        }
    }else if(m_here.island/WIDTH>=2 && m_here.island/WIDTH<=HEIGHT-2 && m_here.toward==1 && m_here.bridge==1){
	    if(m_here.island%WIDTH==0){
	        routeCheck[0]=FALSE;
    	    routeCheck[3]=FALSE;
    	}else if(m_here.island%WIDTH==WIDTH-1){
	        routeCheck[2]=FALSE;
    	    routeCheck[5]=FALSE;
    	}
    }else if(m_here.island/WIDTH>=0 && m_here.island/WIDTH<=HEIGHT-4 && m_here.toward==0 && m_here.bridge==1){
	    if(m_here.island%WIDTH==0){
    	    routeCheck[2]=FALSE;
    	    routeCheck[5]=FALSE;
    	}else if(m_here.island%WIDTH==WIDTH-1){
	        routeCheck[0]=FALSE;
    	    routeCheck[3]=FALSE;
    	}

    }else if(m_here.island%WIDTH==0 && m_here.toward==1 && m_here.bridge==0){
	    routeCheck[1]=FALSE;
    	if(m_here.island/WIDTH==0){
	        routeCheck[2]=FALSE;
        }else if(m_here.island/WIDTH==HEIGHT-1){
	        routeCheck[0]=FALSE;
    	}
    }else if(m_here.island%WIDTH==1 && m_here.toward==1 && m_here.bridge==0){
    	routeCheck[4]=FALSE;
	    if(m_here.island/WIDTH==0){
	        routeCheck[2]=FALSE;
        	routeCheck[5]=FALSE;
	    }else if(m_here.island/WIDTH==HEIGHT-1){
	        routeCheck[0]=FALSE;
    	    routeCheck[3]=FALSE;
    	}
    }else if(m_here.island%WIDTH==WIDTH-3 && m_here.toward==0 && m_here.bridge==0){
	    routeCheck[4]=FALSE;
    	if(m_here.island/WIDTH==0){
	        routeCheck[0]=FALSE;
	        routeCheck[3]=FALSE;
        }else if(m_here.island/WIDTH==HEIGHT-1){
	        routeCheck[2]=FALSE;
	        routeCheck[5]=FALSE;
        }
    }else if(m_here.island%WIDTH==WIDTH-2 && m_here.toward==0 && m_here.bridge==0){
        routeCheck[1]=FALSE;
	    if(m_here.island/WIDTH==0){
    	    routeCheck[0]=FALSE;
        }else if(m_here.island/WIDTH==HEIGHT-1){
	        routeCheck[2]=FALSE;
        }
    }else if(m_here.island%WIDTH>=2 && m_here.island%WIDTH<=WIDTH-2 && m_here.toward==1 && m_here.bridge==0){
    	if(m_here.island/WIDTH==0){
	        routeCheck[2]=FALSE;
    	    routeCheck[5]=FALSE;
    	}else if(m_here.island/WIDTH==HEIGHT-1){
	        routeCheck[0]=FALSE;
    	    routeCheck[3]=FALSE;
    	}
    }else if(m_here.island%WIDTH>=0 && m_here.island%WIDTH<=WIDTH-4 && m_here.toward==0 && m_here.bridge==0){
	    if(m_here.island/WIDTH==0){
	        routeCheck[0]=FALSE;
    	    routeCheck[3]=FALSE;
    	}else if(m_here.island/WIDTH==HEIGHT-1){
	        routeCheck[2]=FALSE;
    	    routeCheck[5]=FALSE;
    	}
    }

    if(m_here.bridge==0 && m_here.toward==0){
        if(routeCheck[0]==TRUE){
        	if(m_be[1][m_here.island-WIDTH+1]==TRUE)	m_route[0]=TRUE;
	        else									m_route[0]=FALSE;
        }else  m_route[0]=FALSE;
        if(routeCheck[1]==TRUE){
    	    if(m_be[0][m_here.island+1]==TRUE)	m_route[1]=TRUE;
    	    else								m_route[1]=FALSE;
        	if(routeCheck[3]==TRUE){
        		if(m_be[1][m_here.island-WIDTH+2]==TRUE)	m_route[3]=TRUE;
    		    else									m_route[3]=FALSE;
    	    }else  m_route[3]=FALSE;
        	if(routeCheck[4]==TRUE){
        		if(m_be[0][m_here.island+2]==TRUE)	m_route[4]=TRUE;
    		    else								m_route[4]=FALSE;
    	    }else  m_route[4]=FALSE;
        	if(routeCheck[5]==TRUE){
        		if(m_be[1][m_here.island+2]==TRUE)	m_route[5]=TRUE;
    		    else								m_route[5]=FALSE;
    	    }else  m_route[5]=FALSE;
        }else  m_route[1]=FALSE;
        if(routeCheck[2]==TRUE){
    	    if(m_be[1][m_here.island+1]==TRUE)	m_route[2]=TRUE;
    	    else								m_route[2]=FALSE;
        }else  m_route[2]=FALSE;
    }else if(m_here.bridge==0 && m_here.toward==1){
        if(routeCheck[0]==TRUE){
    	    if(m_be[1][m_here.island]==TRUE)	m_route[0]=TRUE;
	        else							m_route[0]=FALSE;
        }else  m_route[0]=FALSE;
        if(routeCheck[1]==TRUE){
	        if(m_be[0][m_here.island-1]==TRUE)	m_route[1]=TRUE;
    	    else								m_route[1]=FALSE;
	        if(routeCheck[3]==TRUE){
		        if(m_be[1][m_here.island-1]==TRUE)	m_route[3]=TRUE;
        		else								m_route[3]=FALSE;
	        }else  m_route[3]=FALSE;
	        if(routeCheck[4]==TRUE){
    		    if(m_be[0][m_here.island-2]==TRUE)	m_route[4]=TRUE;
        		else								m_route[4]=FALSE;
	        }else  m_route[4]=FALSE;
    	    if(routeCheck[5]==TRUE){
	    	    if(m_be[1][m_here.island-WIDTH-1]==TRUE)	m_route[5]=TRUE;
        		else									m_route[5]=FALSE;
	        }else  m_route[5]=FALSE;
        }else  m_route[1]=FALSE;
        if(routeCheck[2]==TRUE){
	        if(m_be[1][m_here.island-WIDTH]==TRUE)	m_route[2]=TRUE;
    	    else									m_route[2]=FALSE;
        }else  m_route[2]=FALSE;
    }else if(m_here.bridge==1 && m_here.toward==0){
        if(routeCheck[0]==TRUE){
	        if(m_be[0][m_here.island+WIDTH]==TRUE)	m_route[0]=TRUE;
    	    else									m_route[0]=FALSE;
        }else  m_route[0]=FALSE;
        if(routeCheck[1]==TRUE){
	        if(m_be[1][m_here.island+WIDTH]==TRUE)	m_route[1]=TRUE;
    	    else									m_route[1]=FALSE;
	        if(routeCheck[3]==TRUE){
		        if(m_be[0][m_here.island+2*WIDTH]==TRUE)	m_route[3]=TRUE;
        		else									m_route[3]=FALSE;
	        }else  m_route[3]=FALSE;
	        if(routeCheck[4]==TRUE){
    		    if(m_be[1][m_here.island+2*WIDTH]==TRUE)	m_route[4]=TRUE;
		        else									m_route[4]=FALSE;
        	}else  m_route[4]=FALSE;
	        if(routeCheck[5]==TRUE){
		        if(m_be[0][m_here.island+2*WIDTH-1]==TRUE)	m_route[5]=TRUE;
    		    else										m_route[5]=FALSE;
    	    }else  m_route[5]=FALSE;
        }else  m_route[1]=FALSE;
        if(routeCheck[2]==TRUE){
	        if(m_be[0][m_here.island+WIDTH-1]==TRUE)	m_route[2]=TRUE;
    	    else									m_route[2]=FALSE;
        }else  m_route[2]=FALSE;
    }else if(m_here.bridge==1 && m_here.toward==1){
        if(routeCheck[0]==TRUE){
	        if(m_be[0][m_here.island-1]==TRUE)	m_route[0]=TRUE;
	        else								m_route[0]=FALSE;
        }else  m_route[0]=FALSE;
        if(routeCheck[1]==TRUE){
	        if(m_be[1][m_here.island-WIDTH]==TRUE)	m_route[1]=TRUE;
    	    else									m_route[1]=FALSE;
	        if(routeCheck[3]==TRUE){
		        if(m_be[0][m_here.island-WIDTH-1]==TRUE)	m_route[3]=TRUE;
        		else									m_route[3]=FALSE;
	        }else  m_route[3]=FALSE;
	        if(routeCheck[4]==TRUE){
    		    if(m_be[1][m_here.island-2*WIDTH]==TRUE)	m_route[4]=TRUE;
    		    else									m_route[4]=FALSE;
        	}else  m_route[4]=FALSE;
	        if(routeCheck[5]==TRUE){
		        if(m_be[0][m_here.island-WIDTH]==TRUE)	m_route[5]=TRUE;
   	    	    else									m_route[5]=FALSE;
    	    }else  m_route[5]=FALSE;
        }else  m_route[1]=FALSE;
        if(routeCheck[2]==TRUE){
	        if(m_be[0][m_here.island]==TRUE)	m_route[2]=TRUE;
    	    else							m_route[2]=FALSE;
        }else  m_route[2]=FALSE;
    }
}

void CMaze::GoAhead()
{
    if(m_route[1]==TRUE){
        if(m_here.bridge==0 && m_here.toward==0){
            m_here.island=m_here.island+1;
        }else if(m_here.bridge==0 && m_here.toward==1){
            m_here.island=m_here.island-1;
        }else if(m_here.bridge==1 && m_here.toward==0){
            m_here.island=m_here.island+WIDTH;
        }else if(m_here.bridge==1 && m_here.toward==1){
            m_here.island=m_here.island-WIDTH;
        }        
    }
	CheckRoute();
}

void CMaze::GoLeft()
{
    if(m_route[0]==TRUE){
		if(m_here.bridge==0 && m_here.toward==0){
            m_here.bridge=m_here.bridge+1;
            m_here.island=m_here.island-WIDTH+1;
            m_here.toward=m_here.toward+1;
    	}else if(m_here.bridge==0 && m_here.toward==1){
            m_here.bridge=m_here.bridge+1;
            m_here.toward=m_here.toward-1;
    	}else if(m_here.bridge==1 && m_here.toward==0){
            m_here.bridge=m_here.bridge-1;
            m_here.island=m_here.island+WIDTH;
    	}else if(m_here.bridge==1 && m_here.toward==1){
            m_here.bridge=m_here.bridge-1;
            m_here.island=m_here.island-1;
	    }
    }
	CheckRoute();
}

void CMaze::GoRight()
{
    if(m_route[2]==TRUE){
        if(m_here.bridge==0 && m_here.toward==0){
            m_here.bridge=m_here.bridge+1;
            m_here.island=m_here.island+1;
        }else if(m_here.bridge==0 && m_here.toward==1){
            m_here.bridge=m_here.bridge+1;
            m_here.island=m_here.island-WIDTH;
        }else if(m_here.bridge==1 && m_here.toward==0){
            m_here.bridge=m_here.bridge-1;
            m_here.island=m_here.island+WIDTH-1;
            m_here.toward=m_here.toward+1;
        }else if(m_here.bridge==1 && m_here.toward==1){
            m_here.bridge=m_here.bridge-1;
            m_here.toward=m_here.toward-1;
        }
    }
	CheckRoute();
}

void CMaze::LookBack()
{
	if(m_here.toward==0){
        m_here.toward=1;
    }else if(m_here.toward==1){
        m_here.toward=0;
	}
	CheckRoute();
}

void CMaze::SetData(CMaze* pMaze)
{
	for(int i=0;i<WIDTH*HEIGHT;i++){
		m_be[0][i]=pMaze->m_be[0][i];
		m_be[1][i]=pMaze->m_be[1][i];
	}
	for(int j=0;j<6;j++){
		m_route[j]=pMaze->m_route[j];
	}
	m_here.island=pMaze->m_here.island;
	m_here.bridge=pMaze->m_here.bridge;
	m_here.toward=pMaze->m_here.toward;
}

/////////////////////////////////////////////////////////////////////////////
// CWandererDoc

IMPLEMENT_DYNCREATE(CWandererDoc, CDocument)

BEGIN_MESSAGE_MAP(CWandererDoc, CDocument)
	//{{AFX_MSG_MAP(CWandererDoc)
	ON_COMMAND(ID_APPEAR_YES, OnAppearYes)
	ON_COMMAND(ID_APPEAR_NO, OnAppearNo)
	ON_COMMAND(ID_APPEAR_DAI, OnAppearDai)
	ON_COMMAND(ID_APPEAR_TYUU, OnAppearTyuu)
	ON_COMMAND(ID_APPEAR_SYOU, OnAppearSyou)
	ON_UPDATE_COMMAND_UI(ID_MAP, OnUpdateMap)
	ON_UPDATE_COMMAND_UI(ID_KEYPLACE, OnUpdateKeyplace)
	ON_UPDATE_COMMAND_UI(ID_ARROW, OnUpdateArrow)
	ON_UPDATE_COMMAND_UI(ID_APPEAR_YES, OnUpdateAppearYes)
	ON_UPDATE_COMMAND_UI(ID_APPEAR_NO, OnUpdateAppearNo)
	ON_UPDATE_COMMAND_UI(ID_APPEAR_DAI, OnUpdateAppearDai)
	ON_UPDATE_COMMAND_UI(ID_APPEAR_TYUU, OnUpdateAppearTyuu)
	ON_UPDATE_COMMAND_UI(ID_APPEAR_SYOU, OnUpdateAppearSyou)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWandererDoc NX̍\z/

CWandererDoc::CWandererDoc()
{
	// TODO: ̈ʒuɂPxĂ΂\zp̃R[hǉĂB
}

CWandererDoc::~CWandererDoc()
{
}

BOOL CWandererDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: ̈ʒuɍďǉĂB
	// (SDI hLg͂̃hLgėp܂B)
	
	//*****oϐ̏*****
	//VH
	m_maze.NewMaze();
	//̐_̐ݒ
	m_self.lifepoint=40;
	m_self.attack=40;
	m_self.defense=40;
	//
	m_selftype.lifepoint=40;
	m_selftype.attack=40;
	m_selftype.defense=40;
	//G̐_̐ݒ
	m_enemy.lifepoint=0;
	m_enemy.attack=0;
	m_enemy.defense=0;
	//
	m_enemytype[0].lifepoint=30;
	m_enemytype[0].attack=25;
	m_enemytype[0].defense=25;
	//
	m_enemytype[1].lifepoint=50;
	m_enemytype[1].attack=50;
	m_enemytype[1].defense=50;
	//
	m_enemytype[2].lifepoint=70;
	m_enemytype[2].attack=75;
	m_enemytype[2].defense=75;
	//
	bool ret;
	do{
		ret=PlaceKey();		//zu
	}while(ret);
	m_keycount=0;			//Ă錮͂O
	//
	m_enemycount=0;			//Goϐ̏
	m_frequency=10;			//
	m_appear=TRUE;			//
	//
	m_map=FALSE;			//
	m_keyplace=FALSE;		//
	m_arrow=TRUE;			//
	//
	m_enemyflag=NOENEMY;	//
	m_keyflag=NOKEY;		//
	m_stateflag=START;		//
	//
	m_myAttack=0;			//
	m_enemyAttack=0;		//

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CWandererDoc VAC[[V

void CWandererDoc::Serialize(CArchive& ar)
{
	CMaze* pMaze;
	if (ar.IsStoring())
	{
		// TODO: ̈ʒuɕۑp̃R[hǉĂB
		pMaze=&m_maze;
		ar << pMaze;
		//
		ar << (DWORD)m_self.lifepoint;
		ar << (DWORD)m_self.attack;
		ar << (DWORD)m_self.defense;
		//
		ar << (DWORD)m_selftype.lifepoint;
		ar << (DWORD)m_selftype.attack;
		ar << (DWORD)m_selftype.defense;
		//
		ar << (DWORD)m_enemy.lifepoint;
		ar << (DWORD)m_enemy.attack;
		ar << (DWORD)m_enemy.defense;
		//
		for(int k=0;k<5;k++){
			ar << (DWORD)m_key[k].island;
			ar << (DWORD)m_key[k].toward;
		}
		ar << (DWORD)m_keycount;
		//
		ar << (DWORD)m_enemycount;	//
		ar << (DWORD)m_frequency;	//
		ar << (DWORD)m_appear;		//
		//
		ar << (DWORD)m_map;			//
		ar << (DWORD)m_keyplace;	//
		ar << (DWORD)m_arrow;		//
		//
		ar << (DWORD)m_enemyflag;	//
		ar << (DWORD)m_keyflag;		//
		ar << (DWORD)m_stateflag;	//
		//
		ar << (DWORD)m_myAttack;	//
		ar << (DWORD)m_enemyAttack;	//
	}
	else
	{
		// TODO: ̈ʒuɓǂݍݗp̃R[hǉĂB
		pMaze=new CMaze;
		ar >> pMaze;
		m_maze.SetData(pMaze);
		//
		ar >> (DWORD&)m_self.lifepoint;
		ar >> (DWORD&)m_self.attack;
		ar >> (DWORD&)m_self.defense;
		//
		ar >> (DWORD&)m_selftype.lifepoint;
		ar >> (DWORD&)m_selftype.attack;
		ar >> (DWORD&)m_selftype.defense;
		//
		ar >> (DWORD&)m_enemy.lifepoint;
		ar >> (DWORD&)m_enemy.attack;
		ar >> (DWORD&)m_enemy.defense;
		//
		for(int k=0;k<5;k++){
			ar >> (DWORD&)m_key[k].island;
			ar >> (DWORD&)m_key[k].toward;
		}
		ar >> (DWORD&)m_keycount;
		//
		ar >> (DWORD&)m_enemycount;	//
		ar >> (DWORD&)m_frequency;	//
		ar >> (DWORD&)m_appear;		//
		//
		ar >> (DWORD&)m_map;		//
		ar >> (DWORD&)m_keyplace;	//
		ar >> (DWORD&)m_arrow;		//
		//
		ar >> (DWORD&)m_enemyflag;	//
		ar >> (DWORD&)m_keyflag;	//
		ar >> (DWORD&)m_stateflag;	//
		//
		ar >> (DWORD&)m_myAttack;	//
		ar >> (DWORD&)m_enemyAttack;//
	}
}

/////////////////////////////////////////////////////////////////////////////
// CWandererDoc NX̐ff

#ifdef _DEBUG
void CWandererDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CWandererDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CWandererDoc R}h

void CWandererDoc::CheckFlag()
{
	//stateflag
	place theHere=m_maze.GetHere();
	if(theHere.island==0 && theHere.bridge==0 && theHere.toward==1){
		m_stateflag=STARTPOINT;
	}else if(theHere.island==0 && theHere.bridge==1 && theHere.toward==1){
		m_stateflag=STARTPOINT;
	}else if(theHere.island==89 && theHere.bridge==1 && theHere.toward==0){
		if(m_keycount==5){
			m_stateflag=ENDING;
		}else{
			m_stateflag=ENDPOINT;
		}
	}else if(theHere.island==98 && theHere.bridge==0 && theHere.toward==0){
		if(m_keycount==5){
			m_stateflag=ENDING;
		}else{
			m_stateflag=ENDPOINT;
		}
	}else{
		m_stateflag=WANDERING;
	}
	//keyflag
	if(CheckNearKey()!=-1){
		m_keyflag=DISCOVER;
	}else{
		m_keyflag=NOKEY;
	}
	//enemyflag
	switch(m_enemyflag){
	case NOENEMY:
		if(!m_appear) break;
		if(m_stateflag!=WANDERING) break;
		//
		m_enemycount+=1;
		if(m_enemycount>=m_frequency)
		{
			m_enemycount=0;
			m_enemyflag=APPEAR;
			srand((unsigned)time(NULL));
			int type=rand()%3;
			m_enemy.lifepoint=m_enemytype[type].lifepoint;
			m_enemy.attack=m_enemytype[type].attack;
			m_enemy.defense=m_enemytype[type].defense;
		}
		break;
	case WIN:
		//no return
	case ESCAPE:
		m_enemyflag=NOENEMY;
		break;
	}
	//
	SetModifiedFlag();
}

int CWandererDoc::CheckNearKey()
{
	int myIsland=(m_maze.GetHere()).island;
	int myBridge=(m_maze.GetHere()).bridge;
	int myToward=(m_maze.GetHere()).toward;
    if(myBridge==0 && myToward==0){
        for(int k=0;k<5;k++)
		{
			if( ( m_key[k].island==myIsland+1 ) &&
				( m_key[k].toward==0          )		){return k;}
		}
    }else if(myBridge==0 && myToward==1){
        for(int k=0;k<5;k++)
		{
			if( ( m_key[k].island==myIsland ) &&
				( m_key[k].toward==0        )		){return k;}
		}
    }else if(myBridge==1 && myToward==0){
        for(int k=0;k<5;k++)
		{
			if( ( m_key[k].island==myIsland+WIDTH ) &&
				( m_key[k].toward==0              )		){return k;}
		}
    }else if(myBridge==1 && myToward==1){
        for(int k=0;k<5;k++)
		{
			if( ( m_key[k].island==myIsland ) &&
				( m_key[k].toward==0        )		){return k;}
		}
    }        
	return -1;
}

bool CWandererDoc::CheckFarKey()
{
	int myIsland=(m_maze.GetHere()).island;
	int myBridge=(m_maze.GetHere()).bridge;
	int myToward=(m_maze.GetHere()).toward;
    if(myBridge==0 && myToward==0){
        for(int k=0;k<5;k++)
		{
			if( ( m_key[k].island==myIsland+2 ) &&
				( m_key[k].toward==0          )		){return TRUE;}
		}
    }else if(myBridge==0 && myToward==1){
        for(int k=0;k<5;k++)
		{
			if( ( m_key[k].island==myIsland-1 ) &&
				( m_key[k].toward==0          )		){return TRUE;}
		}
    }else if(myBridge==1 && myToward==0){
        for(int k=0;k<5;k++)
		{
			if( ( m_key[k].island==myIsland+WIDTH*2 ) &&
				( m_key[k].toward==0                )		){return TRUE;}
		}
    }else if(myBridge==1 && myToward==1){
        for(int k=0;k<5;k++)
		{
			if( ( m_key[k].island==myIsland-WIDTH ) &&
				( m_key[k].toward==0              )		){return TRUE;}
		}
    }        
	return FALSE;
}


void CWandererDoc::OnAppearYes(){
	m_appear=TRUE;
	SetModifiedFlag();
}
void CWandererDoc::OnAppearNo(){
	m_appear=FALSE;
	SetModifiedFlag();
}

void CWandererDoc::OnAppearDai(){
	m_frequency=5;
	SetModifiedFlag();
}
void CWandererDoc::OnAppearTyuu(){
	m_frequency=10;
	SetModifiedFlag();
}
void CWandererDoc::OnAppearSyou(){
	m_frequency=15;
	SetModifiedFlag();
}

void CWandererDoc::OnUpdateMap(CCmdUI* pCmdUI){
	pCmdUI->SetCheck((m_map)?1:0);
}
void CWandererDoc::OnUpdateKeyplace(CCmdUI* pCmdUI){
	pCmdUI->SetCheck((m_keyplace)?1:0);
}
void CWandererDoc::OnUpdateArrow(CCmdUI* pCmdUI){
	pCmdUI->SetCheck((m_arrow)?1:0);
}

void CWandererDoc::OnUpdateAppearYes(CCmdUI* pCmdUI){
	pCmdUI->SetCheck((m_appear)?1:0);
}
void CWandererDoc::OnUpdateAppearNo(CCmdUI* pCmdUI){
	pCmdUI->SetCheck((m_appear)?0:1);
}

void CWandererDoc::OnUpdateAppearDai(CCmdUI* pCmdUI){
	pCmdUI->Enable((m_appear)?TRUE:FALSE);
	pCmdUI->SetCheck((m_frequency==5)?1:0);	
}
void CWandererDoc::OnUpdateAppearTyuu(CCmdUI* pCmdUI){
	pCmdUI->Enable((m_appear)?TRUE:FALSE);
	pCmdUI->SetCheck((m_frequency==10)?1:0);	
}
void CWandererDoc::OnUpdateAppearSyou(CCmdUI* pCmdUI){
	pCmdUI->Enable((m_appear)?TRUE:FALSE);
	pCmdUI->SetCheck((m_frequency==15)?1:0);	
}

bool CWandererDoc::PlaceKey()
{
	srand((unsigned)time(NULL));	//̏
	for(int k=0;k<5;k++)			//Ƃ肠zu
	{
		m_key[k].island=rand()%(WIDTH*HEIGHT-3)+2;
		m_key[k].toward=0;
	}
	for(int i=0;i<4;i++){			//ꏊɔzuȂ`FbN
		for(int j=i+1;j<5;j++){
			if(m_key[i].island==m_key[j].island) return TRUE;
		}
	}
	return FALSE;	//ꏊɔzuĂȂFALSEԂ
}
