//******************************************************************
//
//	AvP[V@u@v@v
//
//@@@@@@@@@@@@ҁF[g؁@@@
//@@@@@@@@@@쐬JnFPXXW^V
//@@@@@@@@@@ŏIXVFPXXX^R         [TN010/C01]
//*****************************************************************
//
// WandererDoc.h : CWandererDoc NX̐錾уC^[tFCX̒`܂B
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_WANDERERDOC_H__658586AA_D3FA_11D2_BBB6_444553540000__INCLUDED_)
#define AFX_WANDERERDOC_H__658586AA_D3FA_11D2_BBB6_444553540000__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////
//H̑傫̒萔
#define WIDTH 10	//
#define HEIGHT 10	//

////////////////////////////
//H̒ł̈ʒu\\place
struct place {
	int island;	//
	int bridge;	//
	int toward;	//
};

////////////////////////////
//G̏Ԃ\\life
struct life {
	int lifepoint;	//_
	int attack;		//U
	int defense;	//h
};

////////////////////////////
//tOƂĎg񋓌^flag
enum flag{
	//G̃tO
	NOENEMY,	//G͂Ȃ
	APPEAR,		//Gꂽ
	ATTACK,		//hIAꂩU
	DEFENSE,	//UIAꂩh
	WIN,		//UēG|
	ESCAPE,		//o
	LOOSE,		//h䂵ꂸQ[I[o[
	//̃tO
	NOKEY,		//ĂȂ
	DISCOVER,	//
	PICKUP,		//E
	LEAVE,		//EȂ
	//Ԃ̃tO
	START,		//ꂩX^[g
	STARTPOINT, //Aɂ
	WANDERING,	//Q
	ENDPOINT,	//Aoɂ
	ENDING		//W߂ďoɗ
};

/////////////////////////////////////////////////////////////////////////////
//CMaze
class CMaze : public CObject
{
	DECLARE_SERIAL(CMaze)
private:
	BOOL m_be[2][WIDTH*HEIGHT];
	BOOL m_route[6];
	place m_here;
public:
	CMaze();
	~CMaze();
	void Serialize(CArchive& ar);
	void NewMaze();
    void CheckRoute();
	void GoAhead();
	void GoLeft();
	void GoRight();
	void LookBack();
	void SetData(CMaze* pMaze);
	BOOL GetBe(int x,int y)  { return m_be[x][y]; }
	BOOL GetRoute(int x)     { return m_route[x]; }
	place GetHere()          { return m_here;     }
};

/////////////////////////////////////////////////////////////////////////////
//CWandererDoc
class CWandererDoc : public CDocument
{
	//ViewthNXɂ
	friend class CWandererView;
	//oϐ
	//
	CMaze m_maze;		//HNX̃IuWFNg
	//
	life m_self,		//̎
		 m_enemy;		//񌻂ꂽG
	life m_selftype,	//ő̎
		 m_enemytype[3];//G̃^CviRށj
	//
	place m_key[5];		//HɗĂ錮T
	int m_keycount;		//AW߂Ă錮̐
	//G
	int m_enemycount,	//ړ閈ɑA܂ƓGo
		m_frequency;	//Gpx
	BOOL m_appear;		//G邩ǂ
	//tO
	BOOL m_map,			//\邩
		 m_keyplace,	//Ăʒu\邩
		 m_arrow;		//݈ʒu\邩
	//
	flag m_enemyflag,	//G̃tO
		 m_keyflag,		//̃tO
		 m_stateflag;	//Ԃ̃tO
	//
	int m_myAttack,		//U_
		m_enemyAttack;	//GU_

protected: // VACY@\݂̂쐬܂B
	CWandererDoc();
	DECLARE_DYNCREATE(CWandererDoc)

// Agr[g
public:

// Iy[V
public:

//I[o[Ch
	// ClassWizard ͉z֐̃I[o[Ch𐶐܂B
	//{{AFX_VIRTUAL(CWandererDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	//}}AFX_VIRTUAL

// Cve[V
public:
	virtual ~CWandererDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// ꂽbZ[W }bv֐
protected:
	bool PlaceKey();
	bool CheckFarKey();
	int CheckNearKey();
	void CheckFlag();
	//{{AFX_MSG(CWandererDoc)
	afx_msg void OnAppearYes();
	afx_msg void OnAppearNo();
	afx_msg void OnAppearDai();
	afx_msg void OnAppearTyuu();
	afx_msg void OnAppearSyou();
	afx_msg void OnUpdateMap(CCmdUI* pCmdUI);
	afx_msg void OnUpdateKeyplace(CCmdUI* pCmdUI);
	afx_msg void OnUpdateArrow(CCmdUI* pCmdUI);
	afx_msg void OnUpdateAppearYes(CCmdUI* pCmdUI);
	afx_msg void OnUpdateAppearNo(CCmdUI* pCmdUI);
	afx_msg void OnUpdateAppearDai(CCmdUI* pCmdUI);
	afx_msg void OnUpdateAppearTyuu(CCmdUI* pCmdUI);
	afx_msg void OnUpdateAppearSyou(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ ͑Os̒Oɒǉ̐錾}܂B

#endif // !defined(AFX_WANDERERDOC_H__658586AA_D3FA_11D2_BBB6_444553540000__INCLUDED_)
