// WandererView.cpp : CWandererView NX̓̒`s܂B
//

#include "stdafx.h"
#include "Wanderer.h"

#include "WandererDoc.h"
#include "WandererView.h"
#include "PropertyDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CWandererView

IMPLEMENT_DYNCREATE(CWandererView, CFormView)

BEGIN_MESSAGE_MAP(CWandererView, CFormView)
	//{{AFX_MSG_MAP(CWandererView)
	ON_WM_SIZE()
	ON_COMMAND(ID_MAP, OnMap)
	ON_COMMAND(ID_KEYPLACE, OnKeyplace)
	ON_COMMAND(ID_ARROW, OnArrow)
	ON_BN_CLICKED(IDC_BUTTON_AHEAD, OnButtonAhead)
	ON_BN_CLICKED(IDC_BUTTON_LEFT, OnButtonLeft)
	ON_BN_CLICKED(IDC_BUTTON_RIGHT, OnButtonRight)
	ON_BN_CLICKED(IDC_BUTTON_BACK, OnButtonBack)
	ON_BN_CLICKED(IDC_BUTTON_FIGHT, OnButtonFight)
	ON_BN_CLICKED(IDC_BUTTON_ESCAPE, OnButtonEscape)
	ON_COMMAND(ID_PROPERTY_DLG, OnPropertyDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWandererView NX̍\z/

CWandererView::CWandererView()
	: CFormView(CWandererView::IDD)
{
	//{{AFX_DATA_INIT(CWandererView)
		// : ClassWizard ͂̈ʒuɃȍǉ܂B
	//}}AFX_DATA_INIT
	// TODO: ̏ꏊɍ\zp̃R[hǉĂB

}

CWandererView::~CWandererView()
{
}

void CWandererView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWandererView)
	DDX_Control(pDX, IDC_PROGRESS_SELF, m_self_lp);
	DDX_Control(pDX, IDC_PROGRESS_ENEMY, m_enemy_lp);
	DDX_Control(pDX, IDC_EDIT_COMMENT, m_comment);
	DDX_Control(pDX, IDC_BUTTON_RIGHT, m_right);
	DDX_Control(pDX, IDC_BUTTON_LEFT, m_left);
	DDX_Control(pDX, IDC_BUTTON_FIGHT, m_fight);
	DDX_Control(pDX, IDC_BUTTON_ESCAPE, m_escape);
	DDX_Control(pDX, IDC_BUTTON_BACK, m_back);
	DDX_Control(pDX, IDC_BUTTON_AHEAD, m_ahead);
	//}}AFX_DATA_MAP
}

BOOL CWandererView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ̈ʒu CREATESTRUCT cs C Window NX܂̓X^C
	//  CĂB

	return CFormView::PreCreateWindow(cs);
}

void CWandererView::OnInitialUpdate()
{
	CFormView::OnInitialUpdate();
	GetParentFrame()->RecalcLayout();
	//ResizeParentToFit();

	//ACR{^ɐݒ
	extern CWandererApp theApp;
	HICON iconH;
	iconH=theApp.LoadIcon(IDI_ICON_AHEAD);
	m_ahead.SetIcon(iconH);
	iconH=theApp.LoadIcon(IDI_ICON_LEFT);
	m_left.SetIcon(iconH);
	iconH=theApp.LoadIcon(IDI_ICON_RIGHT);
	m_right.SetIcon(iconH);
	iconH=theApp.LoadIcon(IDI_ICON_BACK);
	m_back.SetIcon(iconH);
}

/////////////////////////////////////////////////////////////////////////////
// CWandererView NX̐ff

#ifdef _DEBUG
void CWandererView::AssertValid() const
{
	CFormView::AssertValid();
}

void CWandererView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CWandererDoc* CWandererView::GetDocument() // fobO o[W̓CCłB
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CWandererDoc)));
	return (CWandererDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CWandererView NX̃bZ[W nh

void CWandererView::OnSize(UINT nType, int cx, int cy) 
{
	CFormView::OnSize(nType, cx, cy);
	
	//TCY̕ύXɍ킹ăRg[zu
	CWnd* ahead=(CButton*)GetDlgItem(IDC_BUTTON_AHEAD);
	CWnd* left=(CButton*)GetDlgItem(IDC_BUTTON_LEFT);
	CWnd* back=(CButton*)GetDlgItem(IDC_BUTTON_BACK);
	CWnd* right=GetDlgItem(IDC_BUTTON_RIGHT);
	CWnd* inside=GetDlgItem(IDC_STATIC_INSIDE);
	CWnd* down=GetDlgItem(IDC_STATIC_DOWN);
	CWnd* sself=GetDlgItem(IDC_STATIC_SELF);
	CWnd* senemy=GetDlgItem(IDC_STATIC_ENEMY);
	CWnd* pself=GetDlgItem(IDC_PROGRESS_SELF);
	CWnd* penemy=GetDlgItem(IDC_PROGRESS_ENEMY);
	CWnd* fight=GetDlgItem(IDC_BUTTON_FIGHT);
	CWnd* escape=GetDlgItem(IDC_BUTTON_ESCAPE);
	CWnd* comment=GetDlgItem(IDC_EDIT_COMMENT);
	//NAŏ̉ʕ`悪܂sĂȂ͉Ȃ
	//Rg[zuĂ鎞MoveWindows
	if(ahead!=NULL){
		ahead->MoveWindow(cx-140,cy-140,60,60);
		left->MoveWindow(cx-210,cy-70,60,60);
		back->MoveWindow(cx-140,cy-70,60,60);
		right->MoveWindow(cx-70,cy-70,60,60);
		inside->MoveWindow(10,10,cx-240,cy-160);
		down->MoveWindow(cx-220,cy-360,207,207);
		sself->MoveWindow(10,cy-140,100,25);
		senemy->MoveWindow(10,cy-115,100,25);
		pself->MoveWindow(110,cy-140,cx-340,25);
		penemy->MoveWindow(110,cy-115,cx-340,25);
		fight->MoveWindow(cx-310,cy-80,80,35);
		escape->MoveWindow(cx-310,cy-45,80,35);
		comment->MoveWindow(10,cy-80,cx-320,70);
	}
}

void CWandererView::OnDraw(CDC* pDC) 
{
	//֐Ŏgpϐ
	CBrush* pOldBrush;
	CPen* pOldPen;
	int px,py,dx,dy;
	//hLgNX̎擾
	CWandererDoc* pDoc=GetDocument();
	//*****摜̍쐬*****
	CRect clientRect;
	GetClientRect(&clientRect);
	CDC memDC;
	memDC.CreateCompatibleDC(pDC);
	CBitmap memBitmap;
	memBitmap.CreateCompatibleBitmap(pDC,clientRect.right,clientRect.bottom);
	CBitmap* pOldBitmap = memDC.SelectObject(&memBitmap);
	memDC.FillSolidRect(clientRect,RGB(192,192,192));
	//*****key*****
	if((pDoc->m_keycount)!=0)					//̕`Q
	{
		px=clientRect.right-210;
		py=(clientRect.bottom-360)/2-25;
		CBitmap keyBMP;
		keyBMP.LoadBitmap(IDB_BITMAP_KEY);
		CDC keyDC;
		keyDC.CreateCompatibleDC(pDC);              
		CBitmap* pKeyOldBMP=keyDC.SelectObject(&keyBMP);
		for(int j=0;j<(pDoc->m_keycount);j++)
		{
			memDC.BitBlt(px+j*40,py,30,50,&keyDC,0,0,SRCCOPY);
		}
		keyDC.SelectObject(pKeyOldBMP);
		keyDC.DeleteDC();
		keyBMP.DeleteObject();
	}
	//*****down*****
	px=clientRect.right-220;		//_̐ݒ
	py=clientRect.bottom-360;
	CBrush blackBrush(RGB(0,0,0));                  //wipuV()̐ݒ
	pOldBrush=memDC.SelectObject(&blackBrush);
	memDC.Rectangle(px,py,px+207,py+207);                   //wi`
	memDC.SelectObject(pOldBrush);
	blackBrush.DeleteObject();
	if(pDoc->m_map){
		pOldPen=(CPen*)memDC.SelectStockObject(WHITE_PEN);	//HpuV()̐ݒ
		for(int i=0;i<HEIGHT;i++){                      //H`
			for(int j=0;j<WIDTH;j++){
				memDC.Rectangle(px+j*20+8,py+i*20+8,px+j*20+8+10,py+i*20+8+10);
			}
		}
		for(int y=0;y<HEIGHT*WIDTH-1;y++){
    		 if(y%WIDTH==WIDTH-1){
				if(pDoc->m_maze.GetBe(1,y)==TRUE){
					memDC.Rectangle(px+(y%WIDTH)*20+8,py+(y/WIDTH)*20+18,px+(y%WIDTH)*20+8+10,py+(y/WIDTH)*20+18+10);
				}
			}else if(y>=(HEIGHT-1)*WIDTH){
				if(pDoc->m_maze.GetBe(0,y)==TRUE){
					memDC.Rectangle(px+(y%WIDTH)*20+18,py+(y/WIDTH)*20+8,px+(y%WIDTH)*20+18+10,py+(y/WIDTH)*20+8+10);
				}
			}else{
				if(pDoc->m_maze.GetBe(1,y)==TRUE){
					memDC.Rectangle(px+(y%WIDTH)*20+8,py+(y/WIDTH)*20+18,px+(y%WIDTH)*20+8+10,py+(y/WIDTH)*20+18+10);
				}
				if(pDoc->m_maze.GetBe(0,y)==TRUE){
					memDC.Rectangle(px+(y%WIDTH)*20+18,py+(y/WIDTH)*20+8,px+(y%WIDTH)*20+18+10,py+(y/WIDTH)*20+8+10);
				}
			}        
		}
		memDC.SelectObject(pOldPen);
	}
	if(pDoc->m_keyplace){
		CPen pinkPen(PS_SOLID,1,RGB(255,0,255));                               //݈ʒupy(sN)̐ݒ
		pOldPen=memDC.SelectObject(&pinkPen);
		CBrush pinkBrush(RGB(255,0,255));                                      //݈ʒupuV(sN)̐ݒ
		pOldBrush=memDC.SelectObject(&pinkBrush);
		for(int k=0;k<5;k++)                                                   //݈ʒu̕`
		{
			int i=pDoc->m_key[k].island;
			if(pDoc->m_key[k].toward==0)
			{
				memDC.SelectObject(&pinkBrush);
			}else{
				memDC.SelectStockObject(NULL_BRUSH);
			}
			memDC.Ellipse(px+(i%WIDTH)*20+8+1,py+(i/WIDTH)*20+8+1,px+(i%WIDTH)*20+8-1+10,py+(i/WIDTH)*20+8-1+10);
		}
		memDC.SelectObject(pOldPen);
		memDC.SelectObject(pOldBrush);
		pinkPen.DeleteObject();
		pinkBrush.DeleteObject();
	}
	CPen bluePen(PS_SOLID,1,RGB(0,0,255));		//X^[gAS[ʒu̕`
	pOldPen=memDC.SelectObject(&bluePen);
	pOldBrush=(CBrush*)memDC.SelectStockObject(NULL_BRUSH);
	memDC.Ellipse(px+8+1,py+8+1,px+8-1+10,py+8-1+10);
	memDC.Ellipse(px+8+1+180,py+8+1+180,px+8-1+180+10,py+8-1+180+10);
	memDC.SelectObject(pOldPen);
	memDC.SelectObject(pOldBrush);
	bluePen.DeleteObject();
	if(pDoc->m_arrow){
		int myIsland=(pDoc->m_maze.GetHere()).island;		//
		int myBridge=(pDoc->m_maze.GetHere()).bridge;
		int myToward=(pDoc->m_maze.GetHere()).toward;
		dx=px+(myIsland%WIDTH)*20;			//
		dy=py+(myIsland/WIDTH)*20;
		CBrush redBrush(RGB(255,0,0));                //puV()̐ݒ
		if(myBridge==0 && myToward==0){
			DrawRgn(&memDC,&redBrush,3,dx+18+1, dx+18+9, dx+18+1, 0,
									   dy+8+1,  dy+8+5,  dy+8+9,  0);
		}else if(myBridge==0 && myToward==1){
			DrawRgn(&memDC,&redBrush,3,dx+18+9, dx+18+1, dx+18+9, 0,
									   dy+8+1,  dy+8+5,  dy+8+9,  0);
		}else if(myBridge==1 && myToward==0){
			DrawRgn(&memDC,&redBrush,3,dx+8+1,  dx+8+5,  dx+8+9,  0,
									   dy+18+1, dy+18+9, dy+18+1, 0);
		}else if(myBridge==1 && myToward==1){
			DrawRgn(&memDC,&redBrush,3,dx+8+1,  dx+8+5,  dx+8+9,  0,
									   dy+18+9, dy+18+1, dy+18+9, 0);
		}
		redBrush.DeleteObject();
	}
	//*****inside*****
	px=10;									//_̐ݒ
	py=10;
	dx=clientRect.right-240;				//ƍ̐ݒ
	dy=clientRect.bottom-160;
	CBrush ceilingBrush(RGB(0,255,255));	//gpuV̍쐬
	CBrush wallBrush(RGB(0,200,0));
	CBrush wall2Brush(RGB(0,255,0));
	CBrush groundBrush(RGB(128,128,128));
	BOOL route[6];							//
	for(int r=0;r<6;r++){
		route[r]=pDoc->m_maze.GetRoute(r);
	}
	DrawRgn(&memDC,&ceilingBrush,4,px, px+dx, px+(int)(dx*3/4), px+(int)(dx/4),
								   py, py,    py+(int)(dy/4),   py+(int)(dy/4) );
	DrawRgn(&memDC,&groundBrush,4,px,    px+dx, px+(int)(dx*3/4), px+(int)(dx/4),
								  py+dy, py+dy, py+(int)(dy*3/4), py+(int)(dy*3/4) );
	DrawRgn(&memDC,&wallBrush,4,px, px,    px+(int)(dx/10),   px+(int)(dx/10),
								py, py+dy, py+(int)(dy*9/10), py+(int)(dy/10) );
	DrawRgn(&memDC,&wallBrush,4,px+dx, px+dx, px+(int)(dx*9/10), px+(int)(dx*9/10),
								py,    py+dy, py+(int)(dy*9/10), py+(int)(dy/10) );
	if(route[0]){
		DrawRgn(&memDC,&ceilingBrush,3,px+(int)(dx/10), px+(int)(dx/10), px+(int)(dx/4), 0,
									   py+(int)(dy/10), py+(int)(dy/4), py+(int)(dy/4), 0);
		DrawRgn(&memDC,&wall2Brush,4,px+(int)(dx/10), px+(int)(dx/10), px+(int)(dx/4), px+(int)(dx/4),
									py+(int)(dy/4), py+(int)(dy*3/4), py+(int)(dy*3/4), py+(int)(dy/4));
		DrawRgn(&memDC,&groundBrush,3,px+(int)(dx/10), px+(int)(dx/10), py+(int)(dx/4), 0,
									  py+(int)(dy*3/4), py+(int)(dy*9/10), py+(int)(dy*3/4), 0);
	}else{
		DrawRgn(&memDC,&wallBrush,4,px+(int)(dx/10), px+(int)(dx/10), px+(int)(dx/4), px+(int)(dx/4),
									   py+(int)(dy/10), py+(int)(dy*9/10), py+(int)(dy*3/4), py+(int)(dy/4));
	}
	if(route[1]){
		DrawRgn(&memDC,&wallBrush,4,px+(int)(dx/4), px+(int)(dx/4), px+(int)(dx*7/20), px+(int)(dx*7/20),
									   py+(int)(dy/4), py+(int)(dy*3/4), py+(int)(dy*13/20), py+(int)(dy*7/20));
		DrawRgn(&memDC,&ceilingBrush,4,px+(int)(dx/4), px+(int)(dx*3/4), px+(int)(dx*3/5), px+(int)(dx*2/5),
									py+(int)(dy/4), py+(int)(dy/4), py+(int)(dy*2/5), py+(int)(dy*2/5));
		DrawRgn(&memDC,&groundBrush,4,px+(int)(dx/4), px+(int)(dx*3/4), px+(int)(dx*3/5), px+(int)(dx*2/5),
									py+(int)(dy*3/4), py+(int)(dy*3/4), py+(int)(dy*3/5), py+(int)(dy*3/5));
		DrawRgn(&memDC,&wallBrush,4,px+(int)(dx*3/4), px+(int)(dx*3/4), py+(int)(dx*13/20), px+(int)(dx*13/20),
									  py+(int)(dy/4), py+(int)(dy*3/4), py+(int)(dy*13/20), py+(int)(dy*7/20));
		if(route[3]){
			DrawRgn(&memDC,&ceilingBrush,3,px+(int)(dx*7/20), px+(int)(dx*7/20), px+(int)(dx*2/5), 0,
										   py+(int)(dy*7/20), py+(int)(dy*2/5), py+(int)(dy*2/5), 0);
			DrawRgn(&memDC,&wall2Brush,4,px+(int)(dx*7/20), px+(int)(dx*7/20), px+(int)(dx*2/5), px+(int)(dx*2/5),
										py+(int)(dy*2/5), py+(int)(dy*3/5), py+(int)(dy*3/5), py+(int)(dy*2/5));
			DrawRgn(&memDC,&groundBrush,3,px+(int)(dx*7/20), px+(int)(dx*7/20), py+(int)(dx*2/5), 0,
										  py+(int)(dy*3/5), py+(int)(dy*13/20), py+(int)(dy*3/5), 0);
		}else{
			DrawRgn(&memDC,&wallBrush,4,px+(int)(dx*7/20), px+(int)(dx*7/20), px+(int)(dx*2/5), px+(int)(dx*2/5),
										   py+(int)(dy*7/20), py+(int)(dy*13/20), py+(int)(dy*3/5), py+(int)(dy*2/5));
		}
		if(route[4]){
			DrawRgn(&memDC,&ceilingBrush,3,px+(int)(dx*2/5), px+(int)(dx*3/5), px+(int)(dx/2), 0,
										   py+(int)(dy*2/5), py+(int)(dy*2/5), py+(int)(dy/2), 0);
			DrawRgn(&memDC,&wallBrush,3,px+(int)(dx*2/5), px+(int)(dx*2/5), px+(int)(dx/2), 0,
										py+(int)(dy*2/5), py+(int)(dy*3/5), py+(int)(dy/2), 0);
			DrawRgn(&memDC,&wallBrush,3,px+(int)(dx*3/5), px+(int)(dx*3/5), px+(int)(dx/2), 0,
										py+(int)(dy*2/5), py+(int)(dy*3/5), py+(int)(dy/2), 0);
			DrawRgn(&memDC,&groundBrush,3,px+(int)(dx*2/5), px+(int)(dx*3/5), py+(int)(dx/2), 0,
										  py+(int)(dy*3/5), py+(int)(dy*3/5), py+(int)(dy/2), 0);
		}else{
			DrawRgn(&memDC,&wall2Brush,4,px+(int)(dx*2/5), px+(int)(dx*3/5), px+(int)(dx*3/5), px+(int)(dx*2/5),
										   py+(int)(dy*2/5), py+(int)(dy*2/5), py+(int)(dy*3/5), py+(int)(dy*3/5));
		}
		if(route[5]){
			DrawRgn(&memDC,&ceilingBrush,3,px+(int)(dx*13/20), px+(int)(dx*13/20), px+(int)(dx*3/5), 0,
										   py+(int)(dy*7/20), py+(int)(dy*2/5), py+(int)(dy*2/5), 0);
			DrawRgn(&memDC,&wall2Brush,4,px+(int)(dx*13/20), px+(int)(dx*13/20), px+(int)(dx*3/5), px+(int)(dx*3/5),
										py+(int)(dy*2/5), py+(int)(dy*3/5), py+(int)(dy*3/5), py+(int)(dy*2/5));
			DrawRgn(&memDC,&groundBrush,3,px+(int)(dx*13/20), px+(int)(dx*13/20), py+(int)(dx*3/5), 0,
										  py+(int)(dy*3/5), py+(int)(dy*13/20), py+(int)(dy*3/5), 0);
		}else{
			DrawRgn(&memDC,&wallBrush,4,px+(int)(dx*13/20), px+(int)(dx*13/20), px+(int)(dx*3/5), px+(int)(dx*3/5),
										   py+(int)(dy*7/20), py+(int)(dy*13/20), py+(int)(dy*3/5), py+(int)(dy*2/5));
		}
	}else{
		DrawRgn(&memDC,&wall2Brush,4,px+(int)(dx/4), px+(int)(dx*3/4), px+(int)(dx*3/4), px+(int)(dx/4),
									   py+(int)(dy/4), py+(int)(dy/4), py+(int)(dy*3/4), py+(int)(dy*3/4));
	}
	if(route[2]){
		DrawRgn(&memDC,&ceilingBrush,3,px+(int)(dx*9/10), px+(int)(dx*9/10), px+(int)(dx*3/4), 0,
									   py+(int)(dy/10), py+(int)(dy/4), py+(int)(dy/4), 0);
		DrawRgn(&memDC,&wall2Brush,4,px+(int)(dx*9/10), px+(int)(dx*9/10), px+(int)(dx*3/4), px+(int)(dx*3/4),
									py+(int)(dy/4), py+(int)(dy*3/4), py+(int)(dy*3/4), py+(int)(dy/4));
		DrawRgn(&memDC,&groundBrush,3,px+(int)(dx*9/10), px+(int)(dx*9/10), py+(int)(dx*3/4), 0,
									  py+(int)(dy*3/4), py+(int)(dy*9/10), py+(int)(dy*3/4), 0);
	}else{
		DrawRgn(&memDC,&wallBrush,4,px+(int)(dx*9/10), px+(int)(dx*9/10), px+(int)(dx*3/4), px+(int)(dx*3/4),
									   py+(int)(dy/10), py+(int)(dy*9/10), py+(int)(dy*3/4), py+(int)(dy/4));
	}
	ceilingBrush.DeleteObject();			//gpuV̍폜
	wallBrush.DeleteObject();
	wall2Brush.DeleteObject();
	groundBrush.DeleteObject();
	if(pDoc->CheckNearKey() != -1){		//Ǒ̕`
		CBitmap keyBMP;
		keyBMP.LoadBitmap(IDB_BITMAP_KEY);
		CDC keyDC;
		keyDC.CreateCompatibleDC(pDC);              
		CBitmap* pKeyOldBMP=keyDC.SelectObject(&keyBMP);
		memDC.BitBlt(px+(int)(dx/2)-7,py+(int)(dy*4/5),21,15,&keyDC,30,50,SRCPAINT);
		memDC.BitBlt(px+(int)(dx/2)-7,py+(int)(dy*4/5),21,15,&keyDC,0,50,SRCAND);
		keyDC.SelectObject(pKeyOldBMP);
		keyDC.DeleteDC();
		keyBMP.DeleteObject();
	}
	if( (route[1]) && (pDoc->CheckFarKey()) ){		//̌̕`
		CBitmap keyBMP;
		keyBMP.LoadBitmap(IDB_BITMAP_KEY);
		CDC keyDC;
		keyDC.CreateCompatibleDC(pDC);              
		CBitmap* pKeyOldBMP=keyDC.SelectObject(&keyBMP);
		memDC.BitBlt(px+(int)(dx/2)-2,py+(int)(dy*5/8),9,5,&keyDC,30,65,SRCPAINT);
		memDC.BitBlt(px+(int)(dx/2)-2,py+(int)(dy*5/8),9,5,&keyDC,0,65,SRCAND);
		keyDC.SelectObject(pKeyOldBMP);
		keyDC.DeleteDC();
		keyBMP.DeleteObject();
	}
	if((pDoc->m_enemy.lifepoint)!=0)                   //G̕`
	{
		CBitmap enemyBMP;
		enemyBMP.LoadBitmap(IDB_BITMAP_ENEMY);
		CDC enemyDC;                           
		enemyDC.CreateCompatibleDC(pDC);
		CBitmap* pEnemyOldBMP=enemyDC.SelectObject(&enemyBMP);
		if(pDoc->m_enemy.attack==pDoc->m_enemytype[0].attack){
			memDC.StretchBlt(px+(int)(dx*1/4),py+(int)(dy*2/5),(int)(dx/2),(int)(dy/2),&enemyDC,80,  0,80,100,SRCPAINT);
			memDC.StretchBlt(px+(int)(dx*1/4),py+(int)(dy*2/5),(int)(dx/2),(int)(dy/2),&enemyDC,0,   0,80,100,SRCAND);
		}else if(pDoc->m_enemy.attack==pDoc->m_enemytype[1].attack){
			memDC.StretchBlt(px+(int)(dx*1/4),py+(int)(dy*2/5),(int)(dx/2),(int)(dy/2),&enemyDC,80,100,80,100,SRCPAINT);
			memDC.StretchBlt(px+(int)(dx*1/4),py+(int)(dy*2/5),(int)(dx/2),(int)(dy/2),&enemyDC,0, 100,80,100,SRCAND);
		}else if(pDoc->m_enemy.attack==pDoc->m_enemytype[2].attack){
			memDC.StretchBlt(px+(int)(dx*1/4),py+(int)(dy*2/5),(int)(dx/2),(int)(dy/2),&enemyDC,80,200,80,100,SRCPAINT);
			memDC.StretchBlt(px+(int)(dx*1/4),py+(int)(dy*2/5),(int)(dx/2),(int)(dy/2),&enemyDC,0, 200,80,100,SRCAND);
		}
		enemyDC.SelectObject(pEnemyOldBMP);
		enemyDC.DeleteDC();
		enemyBMP.DeleteObject();
	}
	//*****摜\ɓ]*****
	pDC->BitBlt(0,0,clientRect.right,clientRect.bottom,&memDC,0,0,SRCCOPY);
	//*****摜̍폜*****
	memDC.SelectObject(pOldBitmap);
	memDC.DeleteDC();
	memBitmap.DeleteObject();
	//*****Rg[*****
	char ss[200];		//
	if(pDoc->m_enemyflag!=NOENEMY){
		switch(pDoc->m_enemyflag){
		case APPEAR:
			m_comment.EnableWindow(TRUE);        
			m_comment.SetWindowText("GꂽI\x0d\x0aǂ܂H");
			m_fight.EnableWindow(TRUE);
			m_fight.SetWindowText("U");
			m_escape.EnableWindow(TRUE);
			m_escape.SetWindowText("");
			EnableArrowButton(FALSE);
			break;
		case ATTACK:
			m_comment.EnableWindow(TRUE);
			if(pDoc->m_enemyAttack==0){
				sprintf(ss,"G̍U\x0d\x0aȂ͊Sɖh䂵I\x0d\x0aǂ܂H");
			}else{
				sprintf(ss,"G̍U\x0d\x0aȂ%d|Cg̃_[W󂯂I\x0d\x0aǂ܂H",pDoc->m_enemyAttack);
			}
			m_comment.SetWindowText(ss);
			m_fight.EnableWindow(TRUE);
			m_fight.SetWindowText("U");
			m_escape.EnableWindow(TRUE);
			m_escape.SetWindowText("");
			EnableArrowButton(FALSE);
			break;
		case DEFENSE:
			m_comment.EnableWindow(TRUE);        
			if(pDoc->m_myAttack==0){
				sprintf(ss,"Ȃ̍U\x0d\x0aG͊Sɖh䂵I\x0d\x0aǂ܂H");
			}else{
				sprintf(ss,"Ȃ̍U\x0d\x0aG%d|Cg̃_[W^I\x0d\x0aǂ܂H",pDoc->m_myAttack);
			}
			m_comment.SetWindowText(ss);
			m_fight.EnableWindow(TRUE);
			m_fight.SetWindowText("h");
			m_escape.EnableWindow(TRUE);
			m_escape.SetWindowText("");
			EnableArrowButton(FALSE);
			break;
		case WIN:
			if(pDoc->m_keyflag==DISCOVER){
				m_comment.EnableWindow(TRUE);        
				sprintf(ss,"Ȃ̍U\x0d\x0aG%d|Cg̃_[W^I@G|I\x0d\x0a_AÚAh͂AbvI\x0d\x0aĂ\x0d\x0aǂ܂H",pDoc->m_myAttack);
				m_comment.SetWindowText(ss);
				m_fight.EnableWindow(TRUE);
				m_fight.SetWindowText("E");
				m_escape.EnableWindow(TRUE);
				m_escape.SetWindowText("EȂ");
				EnableArrowButton(FALSE);
			}else{
				m_comment.EnableWindow(TRUE);        
				sprintf(ss,"Ȃ̍U\x0d\x0aG%d|Cg̃_[W^I\x0d\x0aG|I\x0d\x0a_AÚAh͂AbvI",pDoc->m_myAttack);
				m_comment.SetWindowText(ss);
				m_fight.EnableWindow(FALSE);
				m_escape.EnableWindow(FALSE);
				EnableArrowButton(TRUE);
			}
			break;
		case ESCAPE:
			if(pDoc->m_keyflag==DISCOVER){
				m_comment.EnableWindow(TRUE);
				m_comment.SetWindowText("Ȃ͓oI\x0d\x0a_͉񕜂Ȃ\x0d\x0aĂ\x0d\x0aǂ܂H");
				m_fight.EnableWindow(TRUE);
				m_fight.SetWindowText("E");
				m_escape.EnableWindow(TRUE);
				m_escape.SetWindowText("EȂ");
				EnableArrowButton(FALSE);
			}else{
				m_comment.EnableWindow(TRUE);
				m_comment.SetWindowText("Ȃ͓oI\x0d\x0a_͉񕜂Ȃ");
				m_fight.EnableWindow(FALSE);
				m_escape.EnableWindow(FALSE);
				EnableArrowButton(TRUE);
			}
			break;
		case LOOSE:
			m_comment.EnableWindow(TRUE);        
			sprintf(ss,"G̍U\x0d\x0aȂ%d|Cg̃_[W󂯂I\x0d\x0aȂ͎ł܂I\x0d\x0aQ[I[o[",pDoc->m_enemyAttack);
			m_comment.SetWindowText(ss);
			m_fight.EnableWindow(FALSE);
			m_escape.EnableWindow(FALSE);
			EnableArrowButton(FALSE);
			break;
		}
	}else if(pDoc->m_keyflag!=NOKEY){
		switch(pDoc->m_keyflag){
		case DISCOVER:
			m_comment.EnableWindow(TRUE);
			m_comment.SetWindowText("Ă\x0d\x0aǂ܂H");
			m_fight.EnableWindow(TRUE);
			m_fight.SetWindowText("E");
			m_escape.EnableWindow(TRUE);
			m_escape.SetWindowText("EȂ");
			EnableArrowButton(FALSE);
			break;
		case PICKUP:
			m_comment.EnableWindow(TRUE);
			sprintf(ss,"E\x0d\x0av%d̌W߂",pDoc->m_keycount);
			m_comment.SetWindowText(ss);
			m_fight.EnableWindow(FALSE);
			m_escape.EnableWindow(FALSE);
			EnableArrowButton(TRUE);
			break;
		case LEAVE:
			m_comment.EnableWindow(TRUE);
			sprintf(ss,"EȂ\x0d\x0aĂ錮%dł",pDoc->m_keycount);
			m_comment.SetWindowText(ss);
			m_fight.EnableWindow(FALSE);
			m_escape.EnableWindow(FALSE);
			EnableArrowButton(TRUE);
			break;
		}
	}else if(pDoc->m_stateflag!=WANDERING){
		switch(pDoc->m_stateflag){
		case START:
			m_comment.EnableWindow(TRUE);        
			m_comment.SetWindowText("͓ł\x0d\x0aH̒ɂT̌Ă܂\x0d\x0aSďW߂ďoɍsΒEoł܂");
			m_fight.EnableWindow(FALSE);
			m_escape.EnableWindow(FALSE);
			EnableArrowButton(TRUE);
			break;
		case STARTPOINT:
			m_comment.EnableWindow(TRUE);        
			m_comment.SetWindowText("͓ł\x0d\x0aH̒ɗĂT̌W߂ďoɍsĉ");
			m_fight.EnableWindow(FALSE);
			m_escape.EnableWindow(FALSE);
			EnableArrowButton(TRUE);
			break;
		case ENDPOINT:
			m_comment.EnableWindow(TRUE);        
			m_comment.SetWindowText("͏oł\x0d\x0aTW߂čĂтɗĂ");
			m_fight.EnableWindow(FALSE);
			m_escape.EnableWindow(FALSE);
			EnableArrowButton(TRUE);
			break;
		case ENDING:
			m_comment.EnableWindow(TRUE);        
			m_comment.SetWindowText("߂łƂI\x0d\x0aW߂T̌gďo̔󂯒Eo܂\x0d\x0aȂ̏łI");
			m_fight.EnableWindow(FALSE);
			m_escape.EnableWindow(FALSE);
			EnableArrowButton(FALSE);
			break;
		}
	}else{
		m_comment.EnableWindow(FALSE);        
		m_comment.SetWindowText("");
		m_fight.EnableWindow(FALSE);
		m_escape.EnableWindow(FALSE);
		EnableArrowButton(TRUE);
	}
	m_self_lp.SetRange(0,90);
	m_self_lp.SetPos(pDoc->m_self.lifepoint);
	m_enemy_lp.SetRange(0,90);
	m_enemy_lp.SetPos(pDoc->m_enemy.lifepoint);
}

void CWandererView::DrawRgn(CDC* pMemDC, CBrush* pBrush, int num, int x1, int x2, int x3, int x4, int y1, int y2, int y3, int y4)
{
	POINT myPoint[4];
	myPoint[0].x=x1;	myPoint[0].y=y1;
	myPoint[1].x=x2;	myPoint[1].y=y2;
	myPoint[2].x=x3;	myPoint[2].y=y3;
	myPoint[3].x=x4;	myPoint[3].y=y4;
	CRgn myRgn;
	myRgn.CreatePolygonRgn(&myPoint[0],num,ALTERNATE);
	pMemDC->FillRgn(&myRgn,pBrush);
	myRgn.DeleteObject();
}

void CWandererView::OnMap(){
	CWandererDoc* pDoc=GetDocument();
	pDoc->m_map = !pDoc->m_map;
	pDoc->SetModifiedFlag();
	InvalidateRect(NULL,FALSE);
}
void CWandererView::OnKeyplace(){
	CWandererDoc* pDoc=GetDocument();
	pDoc->m_keyplace = !pDoc->m_keyplace;
	pDoc->SetModifiedFlag();
	InvalidateRect(NULL,FALSE);
}
void CWandererView::OnArrow(){
	CWandererDoc* pDoc=GetDocument();
	pDoc->m_arrow = !pDoc->m_arrow;
	pDoc->SetModifiedFlag();
	InvalidateRect(NULL,FALSE);
}

void CWandererView::OnButtonAhead() 
{
	if(!m_ahead.IsWindowEnabled()) return;
	//
	CWandererDoc* pDoc=GetDocument();
	pDoc->m_maze.GoAhead();
	pDoc->CheckFlag();
	InvalidateRect(NULL,FALSE);
}

void CWandererView::OnButtonLeft() 
{
	if(!m_left.IsWindowEnabled()) return;
	//
	CWandererDoc* pDoc=GetDocument();
	pDoc->m_maze.GoLeft();
	pDoc->CheckFlag();
	InvalidateRect(NULL,FALSE);
}

void CWandererView::OnButtonRight() 
{
	if(!m_right.IsWindowEnabled()) return;
	//
	CWandererDoc* pDoc=GetDocument();
	pDoc->m_maze.GoRight();
	pDoc->CheckFlag();
	InvalidateRect(NULL,FALSE);
}

void CWandererView::OnButtonBack() 
{
	if(!m_back.IsWindowEnabled()) return;
	//
	CWandererDoc* pDoc=GetDocument();
	pDoc->m_maze.LookBack();
	pDoc->CheckFlag();
	InvalidateRect(NULL,FALSE);
}


void CWandererView::EnableArrowButton(bool check)
{
	if(check)
	{
		CWandererDoc* pDoc=GetDocument();
		if(pDoc->m_maze.GetRoute(0)){
			m_left.EnableWindow(TRUE);
		}else{
			m_left.EnableWindow(FALSE);
		}
		if(pDoc->m_maze.GetRoute(1)){
			m_ahead.EnableWindow(TRUE);
		}else{
			m_ahead.EnableWindow(FALSE);
		}
		if(pDoc->m_maze.GetRoute(2)){
			m_right.EnableWindow(TRUE);
		}else{
			m_right.EnableWindow(FALSE);
		}
		m_back.EnableWindow(TRUE);
	}else{
		m_left.EnableWindow(FALSE);
		m_ahead.EnableWindow(FALSE);
		m_right.EnableWindow(FALSE);
		m_back.EnableWindow(FALSE);
	}

}

void CWandererView::OnButtonFight() 
{
	if(!m_fight.IsWindowEnabled()) return;
	//
	CWandererDoc* pDoc=GetDocument();
	//
	CString st;
	m_fight.GetWindowText(st);
	if(st=="U"){
		srand((unsigned)time(NULL));
		pDoc->m_myAttack=(int)(( (pDoc->m_self.attack)*(rand()%6+1)-
								 (pDoc->m_enemy.defense)*(rand()%6+1) )/5);
		if((pDoc->m_myAttack)>0){
			pDoc->m_enemy.lifepoint -= pDoc->m_myAttack;
		}else{
			pDoc->m_myAttack=0;
		}
		if(pDoc->m_enemy.lifepoint<=0)
		{
			pDoc->m_enemy.lifepoint=0;
			if(pDoc->m_selftype.lifepoint<90){
				pDoc->m_selftype.lifepoint+=2;
				pDoc->m_selftype.attack+=2;
				pDoc->m_selftype.defense+=2;
			}
			pDoc->m_self.lifepoint=pDoc->m_selftype.lifepoint;
			pDoc->m_self.attack=pDoc->m_selftype.attack;
			pDoc->m_self.defense=pDoc->m_selftype.defense;
			pDoc->m_enemyflag=WIN;
		}else{
			pDoc->m_enemyflag=DEFENSE;
		}
	}else if(st=="h"){
		srand((unsigned)time(NULL));
		pDoc->m_enemyAttack=(int)(( (pDoc->m_enemy.attack)*(rand()%6+1)-
									(pDoc->m_self.defense)*(rand()%6+1) )/5);
		if((pDoc->m_enemyAttack)>0){
			pDoc->m_self.lifepoint -= pDoc->m_enemyAttack;
		}else{
			pDoc->m_enemyAttack=0;
		}
		if(pDoc->m_self.lifepoint<=0)
		{
			pDoc->m_self.lifepoint=0;
			pDoc->m_enemyflag=LOOSE; 
		}else{
			pDoc->m_enemyflag=ATTACK; 
		}
	}else if(st=="E"){
		if(pDoc->m_enemyflag==ESCAPE || pDoc->m_enemyflag==WIN){
			pDoc->m_enemyflag=NOENEMY;
		}
		pDoc->m_key[pDoc->CheckNearKey()].toward=1;
		pDoc->m_keycount+=1;
		pDoc->m_keyflag=PICKUP;
	}
	//
	pDoc->SetModifiedFlag();
	InvalidateRect(NULL,FALSE);
}

void CWandererView::OnButtonEscape() 
{
	if(!m_escape.IsWindowEnabled()) return;
	//
	CWandererDoc* pDoc=GetDocument();
	//
	CString st;
	m_escape.GetWindowText(st);
	if(st==""){
		pDoc->m_enemy.lifepoint=0;
		pDoc->m_enemyflag=ESCAPE;
	}else if(st=="EȂ"){
		if(pDoc->m_enemyflag==ESCAPE || pDoc->m_enemyflag==WIN){
			pDoc->m_enemyflag=NOENEMY;
		}
		pDoc->m_keyflag=LEAVE;
	}
	//
	pDoc->SetModifiedFlag();
	InvalidateRect(NULL,FALSE);
}

void CWandererView::OnPropertyDlg() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	//
	CWandererDoc* pDoc=GetDocument();
	//
	CPropertyDlg dlg;
	if(pDoc->m_appear){
		dlg.m_appear=1;
	}else{
		dlg.m_appear=0;
	}
	switch(pDoc->m_frequency){
	case 5:
		dlg.m_frequency=0;
		break;
	case 10:
		dlg.m_frequency=1;
		break;
	case 15:
		dlg.m_frequency=2;
		break;
	}
	dlg.m_map=pDoc->m_map;
	dlg.m_arrow=pDoc->m_arrow;
	dlg.m_keyplace=pDoc->m_keyplace;
	//
	if(dlg.DoModal()==IDOK){
		switch(dlg.m_appear){
		case 0:
			pDoc->m_appear=FALSE;
			break;
		case 1:
			pDoc->m_appear=TRUE;
			break;
		}
		switch(dlg.m_frequency){
		case 0:
			pDoc->m_frequency=5;
			break;
		case 1:
			pDoc->m_frequency=10;
			break;
		case 2:
			pDoc->m_frequency=15;
			break;
		}
		pDoc->m_map=dlg.m_map;
		pDoc->m_arrow=dlg.m_arrow;
		pDoc->m_keyplace=dlg.m_keyplace;
		//
		pDoc->SetModifiedFlag();
		InvalidateRect(NULL,FALSE);
	}
	
}
