// PropertyDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "Wanderer.h"
#include "PropertyDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPropertyDlg _CAO


CPropertyDlg::CPropertyDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPropertyDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPropertyDlg)
	m_keyplace = FALSE;
	m_map = FALSE;
	m_frequency = -1;
	m_appear = -1;
	m_arrow = FALSE;
	//}}AFX_DATA_INIT
}


void CPropertyDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPropertyDlg)
	DDX_Control(pDX, IDC_CHECK_ARROW, m_check_arrow);
	DDX_Control(pDX, IDC_RADIO_APPEAR_NO, m_radio_appear);
	DDX_Control(pDX, IDC_RADIO_APPEAR_DAI, m_radio_frequency);
	DDX_Control(pDX, IDC_CHECK_MAP, m_check_map);
	DDX_Control(pDX, IDC_CHECK_KEYPLACE, m_check_keyplace);
	DDX_Control(pDX, IDC_TAB, m_tab);
	DDX_Check(pDX, IDC_CHECK_KEYPLACE, m_keyplace);
	DDX_Check(pDX, IDC_CHECK_MAP, m_map);
	DDX_Radio(pDX, IDC_RADIO_APPEAR_DAI, m_frequency);
	DDX_Radio(pDX, IDC_RADIO_APPEAR_NO, m_appear);
	DDX_Check(pDX, IDC_CHECK_ARROW, m_arrow);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPropertyDlg, CDialog)
	//{{AFX_MSG_MAP(CPropertyDlg)
	ON_NOTIFY(TCN_SELCHANGE, IDC_TAB, OnSelchangeTab)
	ON_BN_CLICKED(IDC_RADIO_APPEAR_YES, OnRadioAppearYes)
	ON_BN_CLICKED(IDC_RADIO_APPEAR_NO, OnRadioAppearNo)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPropertyDlg bZ[W nh

BOOL CPropertyDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: ̈ʒuɏ̕⑫ǉĂ
	TC_ITEM tc0;
	tc0.mask=TCIF_TEXT;
	tc0.pszText="G̏o";
	m_tab.InsertItem(0,&tc0);

	TC_ITEM tc1;
	tc1.mask=TCIF_TEXT;
	tc1.pszText="n}̕\";
	m_tab.InsertItem(1,&tc1);

	m_check_map.ShowWindow(SW_HIDE);
	m_check_keyplace.ShowWindow(SW_HIDE);
	m_check_arrow.ShowWindow(SW_HIDE);
	
	if(m_appear==0){
		GetDlgItem(IDC_RADIO_APPEAR_DAI)->EnableWindow(FALSE);
		GetDlgItem(IDC_RADIO_APPEAR_TYUU)->EnableWindow(FALSE);
		GetDlgItem(IDC_RADIO_APPEAR_SYOU)->EnableWindow(FALSE);
	}
	
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

void CPropertyDlg::OnSelchangeTab(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	int n=m_tab.GetCurSel();
	
	GetDlgItem(IDC_RADIO_APPEAR_YES)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_RADIO_APPEAR_NO)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_RADIO_APPEAR_DAI)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_RADIO_APPEAR_TYUU)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_RADIO_APPEAR_SYOU)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_STATIC_FREQUENCY)->ShowWindow(SW_HIDE);
	m_check_map.ShowWindow(SW_HIDE);
	m_check_keyplace.ShowWindow(SW_HIDE);
	m_check_arrow.ShowWindow(SW_HIDE);

	if(n==0)
	{
		GetDlgItem(IDC_RADIO_APPEAR_YES)->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_RADIO_APPEAR_NO)->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_RADIO_APPEAR_DAI)->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_RADIO_APPEAR_TYUU)->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_RADIO_APPEAR_SYOU)->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_STATIC_FREQUENCY)->ShowWindow(SW_SHOW);
		if(m_appear==0){
			GetDlgItem(IDC_RADIO_APPEAR_DAI)->EnableWindow(FALSE);
			GetDlgItem(IDC_RADIO_APPEAR_TYUU)->EnableWindow(FALSE);
			GetDlgItem(IDC_RADIO_APPEAR_SYOU)->EnableWindow(FALSE);
		}
	}else if(n==1){
		m_check_map.ShowWindow(SW_SHOW);
		m_check_keyplace.ShowWindow(SW_SHOW);
		m_check_arrow.ShowWindow(SW_SHOW);
	}
	
	*pResult = 0;
}

void CPropertyDlg::OnRadioAppearYes() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	GetDlgItem(IDC_RADIO_APPEAR_DAI)->EnableWindow(TRUE);
	GetDlgItem(IDC_RADIO_APPEAR_TYUU)->EnableWindow(TRUE);
	GetDlgItem(IDC_RADIO_APPEAR_SYOU)->EnableWindow(TRUE);
	
}

void CPropertyDlg::OnRadioAppearNo() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	GetDlgItem(IDC_RADIO_APPEAR_DAI)->EnableWindow(FALSE);
	GetDlgItem(IDC_RADIO_APPEAR_TYUU)->EnableWindow(FALSE);
	GetDlgItem(IDC_RADIO_APPEAR_SYOU)->EnableWindow(FALSE);
	
}
